%___________________________________________________________________%
%   SAND CAT OPTIMIZATION ALGORITHM source codes                    %
%   Author and programmer: AMIR SEYYEDABBASI                        %
%   e-Mail: amir.seyedabbasi@gmail.com                              %                                                                 %
%   Main paper: A. Seyyedabbasi, F. kiani                           %
%   DOI: https://doi.org/10.1007/s00366-022-01604-x                 %
%___________________________________________________________________%
function [bestX,bestFx]=CatFx(fx,Lb,Ub,MaxPop,MaxIters)
  nVars = length(Lb);
  bestX=zeros(1,nVars);
  bestFx=inf;
  pop = zeros(MaxPop,nVars);
  for i=1:MaxPop
    pop(i,:) = Lb + (Ub - Lb).*rand(1,nVars);
  end
  p=1:360;
  for iter=1:MaxIters
    for i=1:MaxPop
      for j=1:nVars
        if pop(i,j) < Lb(j) || pop(i,j) > Ub(j)
          pop(i,j) = Lb(j) + (Ub(j) - Lb(j))*rand;
        end
        fitness=fx(pop(i,:));
        if fitness < bestFx
          bestFx = fitness;
          bestX = pop(i,:);
          fprintf("Iter: %d, Fx = %e, X=[", iter, bestFx);
          fprintf("%f, ", bestX(1:nVars-1));
          fprintf("%f]\n", bestX(nVars));
        end
      end
      S=2;                                    %%% S is maximum Sensitivity range
      rg=S-((S)*iter/(MaxIters));                %%%% guides R
      for i=1:MaxPop
        r=rand*rg;
        R=((2*rg)*rand)-rg;                 %%%%   controls to transtion phases
        for j=1:nVars
          teta=RouletteWheelSelection(p);
          if((-1<=R)&&(R<=1))              %%%% R value is between -1 and 1
            Rand_position=abs(rand*bestX(j)-pop(i,j));
            pop(i,j)=bestX(j)-r*Rand_position*cos(teta);
          else
            cp=floor(MaxPop*rand()+1);
            CandidatePosition =pop(cp,:);
            pop(i,j)=r*(CandidatePosition(j)-rand*pop(i,j));
          end
        end
      end
    end
  end
end

