% Implementation does ok. Struggles a bit with fx9, needing maxpop of 500

%___________________________________________________________________%
%   SAND CAT OPTIMIZATION ALGORITHM source codes                    %
%   Author and programmer: AMIR SEYYEDABBASI                        %
%   e-Mail: amir.seyedabbasi@gmail.com                              %                                                                 %
%   Main paper: A. Seyyedabbasi, F. kiani                           %
%   DOI: https://doi.org/10.1007/s00366-022-01604-x                 %
%___________________________________________________________________%
function [bestX,bestFx]=CatFxEnh(fx,Lb,Ub,MaxPop,MaxIters)
  nVars = length(Lb);
  bestX=zeros(1,nVars);
  bestFx=inf;
  pop = zeros(MaxPop,nVars);
  for i=1:MaxPop
    pop(i,:) = Lb + (Ub - Lb).*rand(1,nVars);
    fitness = fx(pop(i,:));
    if fitness < bestFx
      bestFx = fitness;
      bestX = pop(i,:);
    end
  end
  p=1:360;
  halfMaxIters = fix(MaxIters/2);
  for iter=1:MaxIters
    if iter == halfMaxIters
      for i=1:nVars
        if bestX(i) > 0
          Lb(i) = 0.85*bestX(i);
          Ub(i) = 1.15*bestX(i);
        elseif bestX(i) < 0
          Lb(i) = 1.15*bestX(i);
          Ub(i) = 0.85*bestX(i);
        else
          Lb(i) = -0.05;
          Ub(i) = 0.05;
        end   
      end
      fprintf("New Lb =[");
      fprintf("%f, ", Lb(1:nVars-1));
      fprintf("%f]\n", Lb(nVars));
      fprintf("New Ub =[");
      fprintf("%f, ", Ub(1:nVars-1));
      fprintf("%f]\n", Ub(nVars));   
    end    
    for i=1:MaxPop
      for j=1:nVars
        if pop(i,j) < Lb(j) || pop(i,j) > Ub(j)
          pop(i,j) = Lb(j) + (Ub(j) - Lb(j))*rand;
        end
      end
      fitness=fx(pop(i,:));
      if fitness < bestFx
        bestFx = fitness;
        bestX = pop(i,:);

        Lb2 = Lb;
        Ub2 = Ub;
        for i2=1:nVars
          if bestX(i2) > 0
            Lb2(i2) = 0.95*bestX(i2);
            Ub2(i2) = 1.05*bestX(i2);
          elseif bestX(i2) < 0
            Lb2(i2) = 1.05*bestX(i2);
            Ub2(i2) = 0.95*bestX(i2);
          else
            Lb2(i2) = -0.05;
            Ub2(i2) = 0.05;
          end
          if Lb2(i2) < Lb(i2), Lb2(i2) = Lb(i2); end
          if Ub2(i2) > Ub(i2), Ub2(i2) = Ub(i2); end
        end
        x2 = zeros(1,nVars);
        for it=1:100
          for i2=1:nVars
            x2(i2) = Lb2(i2) + (Ub2(i2) - Lb2(i2))*rand;
          end
          f2 = fx(x2);
          if f2 < bestFx
            bestX = x2;
            bestFx = f2;
          end
        end

        fprintf("Iter: %d, Fx = %e, X=[", iter, bestFx);
        fprintf("%f, ", bestX(1:nVars-1));
        fprintf("%f]\n", bestX(nVars));
      end
      % end
      S=2;                                    %%% S is maximum Sensitivity range
      rg=S-((S)*iter/(MaxIters));                %%%% guides R
      for i=1:MaxPop
        r=rand*rg;
        R=((2*rg)*rand)-rg;                 %%%%   controls to transtion phases
        for j=1:nVars
          teta=RouletteWheelSelection(p);
          if((-1<=R)&&(R<=1))              %%%% R value is between -1 and 1
            Rand_position=abs(rand*bestX(j)-pop(i,j));
            pop(i,j)=bestX(j)-r*Rand_position*cos(teta);
          else
            cp=floor(MaxPop*rand()+1);
            CandidatePosition =pop(cp,:);
            pop(i,j)=r*(CandidatePosition(j)-rand*pop(i,j));
          end
        end
      end
    end
  end
end

